/**
 * The program(s) herein may be used  freely
 * for personal use only. It may not be sold, 
 * rented, leased, sublicensed  or  modified 
 * without permission of  the  author.  
 * 
 *           www.carlosbcruz.com
 *           
 * This program is provided "AS IS"  without 
 * warranty of any kind. In no event I  will
 * be liable  for  any  direct  or  indirect 
 * damage.
 */

package com.carlosbcruz.duplicated;

import java.io.File;
import java.util.ArrayList;

/**
 * Provider of specific Actions to the com.carlosbcruz.account.control application. The Actions
 * are inner class of AccountActions.
 *  
 * @author Carlos Fernando Bella Cruz - <a href="mailto:pessoal@carlosbcruz.com">pessoal@carlosbcruz.com</a>
 */
public class FindDuplicated {

	static File[] files;

	static ArrayList fileNames = new ArrayList();

	private StringBuffer showDirectories(File file[], int level) {

		StringBuffer out = new StringBuffer();

		for (int i = 0; i < file.length; i++) {

			if (file[i].isDirectory()) {
				out.append(file[i]);
				out.append("\r\n");
				out.append(showDirectories(file[i].listFiles(), level + 2));
			} else {
				out.append(file[i]);
				fileNames.add(file[i]);
				out.append("\r\n");
			}
		}

		return out;
	}

	/**
	 * Find files with the same name and size.
	 * @param args The target directory.
	 */
	public static void main(String[] args) {

		if (args.length != 1) {
			System.out
					.println("Usage: java -jar FindDuplicated target_directory");
			System.exit(0);
		}

		FindDuplicated dir = new FindDuplicated();

		StringBuffer out = new StringBuffer();

		out.append(dir.showDirectories(new File[] { new File(args[0]) }, 0));
		int numberOfDuplicated = 0;

		for (int i = 0; i < fileNames.size(); i++) {
			File file_i = (File) fileNames.get(i);

			for (int j = i + 1; j < fileNames.size(); j++) {
				File file_j = (File) fileNames.get(j);

				if (file_i.getName().equals(file_j.getName())
						&& file_i.length() == file_j.length()) {
					System.out.println("Duplicated " + (++numberOfDuplicated)
							+ ": ");
					System.out.println("	" + file_i);
					System.out.println("	" + file_j);

				}
			}
		}
	}
}
