/**
 * The program(s) herein may be used  freely
 * for personal use only. It may not be sold, 
 * rented, leased, sublicensed  or  modified 
 * without permission of  the  author.  
 * 
 *           www.carlosbcruz.com
 *           
 * This program is provided "AS IS"  without 
 * warranty of any kind. In no event I  will
 * be liable  for  any  direct  or  indirect 
 * damage.
 */

package com.carlosbcruz.percurse.beans;

import java.io.Serializable;

/**
 * Hold a specific instance of a com.carlosbcruz.percurse
 * 
 * @author Carlos Fernando Bella Cruz - <a
 *         href="mailto:pessoal@carlosbcruz.com">pessoal@carlosbcruz.com</a>
 */
public class PercurseBean implements Serializable {

	private static final long serialVersionUID = 1L;

	private int day, month, year;

	private int startHour, startMinute, endHour, endMinute;

	private String category;

	private long odometer;

	/**
	 * Create a specific com.carlosbcruz.percurse bean
	 * 
	 * @param day
	 * @param month
	 * @param year
	 * @param startHour
	 * @param startMinute
	 * @param endHour
	 * @param endMinute
	 * @param category
	 * @param odometer
	 */
	public PercurseBean(int day, int month, int year, int startHour,
			int startMinute, int endHour, int endMinute, String category,
			long odometer) {

		this.day = day;
		this.month = month;
		this.year = year;
		this.startHour = startHour;
		this.startMinute = startMinute;
		this.endHour = endHour;
		this.endMinute = endMinute;
		this.category = category;
		this.odometer = odometer;
	}

	/**
	 * Get bean property
	 * 
	 * @return category
	 */
	public String getCategory() {
		return category;
	}

	/**
	 * Get bean property
	 * 
	 * @return day
	 */
	public int getDay() {
		return day;
	}

	/**
	 * Get bean property
	 * 
	 * @return month
	 */
	public int getMonth() {
		return month;
	}

	/**
	 * Get bean property
	 * 
	 * @return odometer
	 */
	public long getOdometer() {
		return odometer;
	}

	/**
	 * Get bean property
	 * 
	 * @return year
	 */
	public int getYear() {
		return year;
	}

	/**
	 * Get bean property
	 * 
	 * @return End Hour
	 */
	public int getEndHour() {
		return endHour;
	}

	/**
	 * Get bean property
	 * 
	 * @return End Minute
	 */
	public int getEndMinute() {
		return endMinute;
	}

	/**
	 * Get bean property
	 * 
	 * @return Start Hour
	 */
	public int getStartHour() {
		return startHour;
	}

	/**
	 * Get bean property
	 * 
	 * @return Start Minute
	 */
	public int getStartMinute() {
		return startMinute;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString() {

		StringBuffer buffer = new StringBuffer();

		buffer.append("PercurseBean(" + month + "/" + day + "/" + year + " "
				+ startHour + ":" + startMinute + " " + endHour + ":"
				+ endMinute + " " + category + " " + odometer + ")");

		return buffer.toString();
	}
}
