/**
 * The program(s) herein may be used  freely
 * for personal use only. It may not be sold, 
 * rented, leased, sublicensed  or  modified 
 * without permission of  the  author.  
 * 
 *           www.carlosbcruz.com
 *           
 * This program is provided "AS IS"  without 
 * warranty of any kind. In no event I  will
 * be liable  for  any  direct  or  indirect 
 * damage.
 */
package com.carlosbcruz.percurse.logic;

import com.carlosbcruz.percurse.beans.FuelBean;
import com.carlosbcruz.percurse.beans.FuelViewBean;
import com.carlosbcruz.percurse.beans.PercurseBean;
import com.carlosbcruz.percurse.beans.PercurseViewBean;

/**
 * Implements the main logic.
 * 
 * @author Carlos Fernando Bella Cruz - <a
 *         href="mailto:pessoal@carlosbcruz.com">pessoal@carlosbcruz.com</a>
 */
public class PercurseLogic {

	private FuelViewBean[] fuelViewArray;

	private PercurseViewBean[] percurseViewArray;

	/**
	 * Extract information from com.carlosbcruz.percurse and fuel
	 * 
	 * @param percurseArray
	 *            the percurses information
	 * @param fuelArray
	 *            the fuel information
	 */
	public PercurseLogic(PercurseBean[] percurseArray, FuelBean[] fuelArray) {

		fuelViewArray = new FuelViewBean[fuelArray.length];
		// Create the correspondent fuel view bean array
		for (int i = 0; i < fuelArray.length; i++)
			fuelViewArray[i] = new FuelViewBean(fuelArray[i]);

		// There is a positioning coorelation between percurseArray and
		// percurseAnalysis
		percurseViewArray = new PercurseViewBean[percurseArray.length];
		// Create the correspondent com.carlosbcruz.percurse view bean array
		for (int i = 0; i < percurseArray.length; i++)
			percurseViewArray[i] = new PercurseViewBean(percurseArray[i]);

		calculateDistances();
	}

	private void calculateDistances() {

		for (int i = 1; i < percurseViewArray.length; i++) {
			percurseViewArray[i].setPartialOdometer(percurseViewArray[i]
					.getOdometer()
					- percurseViewArray[i - 1].getOdometer());
		}

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString() {

		StringBuffer buffer = new StringBuffer();

		for (int i = 0; i < percurseViewArray.length; i++) {
			buffer.append(percurseViewArray[i]
					+ System.getProperty("line.separator"));
		}

		return buffer.toString();
	}

}