/**
 * The program(s) herein may be used  freely
 * for personal use only. It may not be sold, 
 * rented, leased, sublicensed  or  modified 
 * without permission of  the  author.  
 * 
 *           www.carlosbcruz.com
 *           
 * This program is provided "AS IS"  without 
 * warranty of any kind. In no event I  will
 * be liable  for  any  direct  or  indirect 
 * damage.
 */
package com.carlosbcruz.percurse.util;

/**
 * Inform of Comma Separeted Exception
 * 
 * @author Carlos Fernando Bella Cruz - <a
 *         href="mailto:pessoal@carlosbcruz.com">pessoal@carlosbcruz.com</a>
 */
public class CommaSeparetedException extends Exception {

	private static final long serialVersionUID = 1L;

	private String simpleMessageText = CommaSeparetedValuesConstants
			.getMessage(CommaSeparetedValuesConstants.INITIAL_COMMA_SEPARETED_EXCEPTION_MESSAGE);

	private int line = -1, column = -1;

	String element = CommaSeparetedValuesConstants
			.getMessage(CommaSeparetedValuesConstants.INITIAL_COMMA_SEPARETED_EXCEPTION_MESSAGE);

	/**
	 * Construct a simple reader exception with a simplified message
	 * 
	 * @param newSimpleMessageText
	 */
	public CommaSeparetedException(String newSimpleMessageText, int line,
			int column, String element) {

		simpleMessageText = newSimpleMessageText;
		this.line = line;
		this.column = column;
		this.element = element;
	}

	/**
	 * Get simplified message text
	 * 
	 * @return message
	 */
	public String getSimpleMessageText() {
		return simpleMessageText;
	}

	/**
	 * Set simplified message text
	 * 
	 * @param newSimpleMessageText
	 */
	public void setSimpleMessageText(String newSimpleMessageText) {
		simpleMessageText = newSimpleMessageText;
	}

	/**
	 * Return the additional information for the comma separeted exception
	 * 
	 * @return The additional message
	 */
	private String getAdditionalMessage() {

		return simpleMessageText + ": Error reading line " + line
				+ " on column " + column + " containing token " + element;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Throwable#getMessage()
	 */
	public String getMessage() {
		return getAdditionalMessage() + super.getMessage();
	}
}
