/**
 * The program(s) herein may be used  freely
 * for personal use only. It may not be sold, 
 * rented, leased, sublicensed  or  modified 
 * without permission of  the  author.  
 * 
 *           www.carlosbcruz.com
 *           
 * This program is provided "AS IS"  without 
 * warranty of any kind. In no event I  will
 * be liable  for  any  direct  or  indirect 
 * damage.
 */

package com.carlosbcruz.replacestring;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.JOptionPane;

/**
 * Save Files
 * 
 * @author Carlos Fernando Bella Cruz - <a
 *         href="mailto:pessoal@carlosbcruz.com">pessoal@carlosbcruz.com</a>
 */
public class FileSaver {

	// The number of bytes to read
	private long lengthOfTask;

	// Actual file that is being read
	private long current;

	// Message of the current status.
	private String statMessage;

	// Internal Windows that are generated to the files.
	private ArrayList intarnalDocuments;
	private ArrayList newIntarnalDocuments = new ArrayList();

	// List of files to work
	private ArrayList internalDocuments;

	private String directory;

	boolean stop = false;

	private File file;
	private FileWriter fileWriter;

	/**
	 * Constructor. Get the file list and count the total number of bytes.
	 */
	FileSaver(ArrayList internalDocuments, String directory) {

		// Get the file names
		this.internalDocuments = internalDocuments;
		this.directory = directory;

		// Count the number of bytes to read
		long counter = 0;
		Iterator documentsIterator = internalDocuments.iterator();
		while (documentsIterator.hasNext()) {
			InternalDocument documentfile = (InternalDocument) documentsIterator
					.next();
			counter++;
		}
		lengthOfTask = counter;
	}

	/**
	 * Start the process of reading the files through an inner class ActualTask.
	 */
	void go() {
		current = 0;
		final SwingWorker worker = new SwingWorker() {
			public Object construct() {
				return new ActualTask();
			}
		};

		worker.start();
	}

	/**
	 * Get the total number of bytes to read
	 */
	long getLengthOfTask() {
		return lengthOfTask;
	}

	/**
	 * Get the total number of bytes readed until the moment of this method
	 * call.
	 */
	long getCurrent() {
		return current;
	}

	/**
	 * Stop the reading
	 */
	void stop() {
		stop = true;
		current = lengthOfTask;
	}

	/**
	 * Inform if the read is completed
	 */
	boolean done() {
		return (current >= lengthOfTask);
	}

	/**
	 * Return the current message status
	 */
	String getMessage() {
		return statMessage;
	}

	/**
	 * Class to perform the reading
	 */
	class ActualTask {

		/**
		 * Constructor to perform the reading
		 */
		ActualTask() {

			stop = false;

			current = 0;

			for (int f = 0; f < internalDocuments.size(); f++) {

				if (stop)
					return;

				InternalDocument document = (InternalDocument) internalDocuments
						.get(f);

				File outputFile = new File(directory
						+ document.getTitle()
								.substring(
										document.getTitle().lastIndexOf(
												File.separator)));

				try {
					FileWriter writer = new FileWriter(outputFile);

					writer.write(document.getContent().toString());
					writer.close();
				} catch (IOException e) {
					JOptionPane.showMessageDialog(null,
							"Error found while writing file: "
									+ document.getTitle() + " " + e.toString(),
							"Warning", JOptionPane.WARNING_MESSAGE);

				}
				current++;
				statMessage = "Completed " + current + " of " + lengthOfTask;
			}
		}

		/**
		 * Returns the newIntarnalDocuments.
		 * 
		 * @return ArrayList
		 */
		public ArrayList getNewIntarnalDocuments() {
			return newIntarnalDocuments;
		}

	}

}
