/**
 * The program(s) herein may be used  freely
 * for personal use only. It may not be sold, 
 * rented, leased, sublicensed  or  modified 
 * without permission of  the  author.  
 * 
 *           www.carlosbcruz.com
 *           
 * This program is provided "AS IS"  without 
 * warranty of any kind. In no event I  will
 * be liable  for  any  direct  or  indirect 
 * damage.
 */

/**
 * Build the menu and allow others to listem to some actions.
 */

package com.carlosbcruz.replacestring;

import java.awt.event.ActionListener;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;

/**
 * Main class.
 * 
 * @author Carlos Fernando Bella Cruz - <a
 *         href="mailto:pessoal@carlosbcruz.com">pessoal@carlosbcruz.com</a>
 */
public class MainMenu extends JMenuBar implements ItensSelectionListener,
		HasFilesListener {

	private JMenuItem selectMenuItem, saveMenuItem, exitMenuItem,
			showFilesMenuItem, replaceStringMenuItem, aboutItem;

	/**
	 * Constructor
	 */

	MainMenu() {

		super();

		buildMainMenu();
	}

	/**
	 * Build all the menu hierarchi
	 */
	private void buildMainMenu() {

		JMenu menu = new JMenu("Files");
		menu.setMnemonic('F');

		// Select files menu item
		selectMenuItem = new JMenuItem("Select Files");
		selectMenuItem.setMnemonic('S');
		menu.add(selectMenuItem);

		// Save files menu item
		saveMenuItem = new JMenuItem("Save Files");
		saveMenuItem.setEnabled(false);
		saveMenuItem.setMnemonic('a');
		menu.add(saveMenuItem);

		// Exit menu item
		exitMenuItem = new JMenuItem("Exit");
		exitMenuItem.setMnemonic('E');
		menu.add(exitMenuItem);

		JMenu secondMenu = new JMenu("Actions");
		secondMenu.setMnemonic('A');

		// Replace String
		replaceStringMenuItem = new JMenuItem("Replace Strings");
		replaceStringMenuItem.setEnabled(false);
		replaceStringMenuItem.setMnemonic('R');
		secondMenu.add(replaceStringMenuItem);

		// Show files menu item
		showFilesMenuItem = new JMenuItem("Show Selected Files");
		showFilesMenuItem.setEnabled(false);
		showFilesMenuItem.setMnemonic('S');
		secondMenu.add(showFilesMenuItem);

		JMenu thirdMenu = new JMenu("Help");
		thirdMenu.setMnemonic('H');

		// About menu item
		aboutItem = new JMenuItem("About");
		aboutItem.setEnabled(true);
		aboutItem.setMnemonic('A');
		thirdMenu.add(aboutItem);

		add(menu);
		add(secondMenu);
		add(thirdMenu);

	}

	/**
	 * All others to listem to some actions
	 */
	public void addExitActionListener(ActionListener actionListener) {
		exitMenuItem.addActionListener(actionListener);
	}

	/**
	 * All others to listem to some actions
	 */
	public void addSelectActionListener(ActionListener actionListener) {
		selectMenuItem.addActionListener(actionListener);
	}

	/**
	 * All others to listem to some actions
	 */
	public void addSaveActionListener(ActionListener actionListener) {
		saveMenuItem.addActionListener(actionListener);
	}

	/**
	 * All others to listem to some actions
	 */
	public void addReplaceStringActionListener(ActionListener actionListener) {
		replaceStringMenuItem.addActionListener(actionListener);
	}

	/**
	 * All others to listem to some actions
	 */
	public void addShowFilesActionListener(ActionListener actionListener) {
		showFilesMenuItem.addActionListener(actionListener);
	}

	/**
	 * All others to listem to some actions
	 */
	public void addAboutActionListener(ActionListener actionListener) {
		aboutItem.addActionListener(actionListener);
	}

	/**
	 * Set the show files menu enabled status
	 */
	public void setEnabledShowFilesMenuItem(boolean newStatus) {
		showFilesMenuItem.setEnabled(newStatus);
	}

	/**
	 * No files were selected
	 */
	public void noItensSelected() {
		showFilesMenuItem.setEnabled(false);
	}

	/**
	 * Some files were selected
	 */
	public void someItensSelected() {
		showFilesMenuItem.setEnabled(true);
	}

	/**
	 * There are files
	 */
	public void hasFiles() {
		saveMenuItem.setEnabled(true);
		replaceStringMenuItem.setEnabled(true);
	}
}