/**
 * The program(s) herein may be used  freely
 * for personal use only. It may not be sold, 
 * rented, leased, sublicensed  or  modified 
 * without permission of  the  author.  
 * 
 *           www.carlosbcruz.com
 *           
 * This program is provided "AS IS"  without 
 * warranty of any kind. In no event I  will
 * be liable  for  any  direct  or  indirect 
 * damage.
 */

package com.carlosbcruz.form;

import java.io.Serializable;
import java.util.List;

/**
 * Simple class to hold test information
 * 
 * @author Carlos Fernando Bella Cruz - <a
 *         href="mailto:pessoal@carlosbcruz.com">pessoal@carlosbcruz.com</a>
 */
public class TestForm implements Serializable {

	private static final long serialVersionUID = 1L;

	int value = 0;

	String text = new String();

	List elements = null;

	/**
	 * @param value
	 * @param text
	 * @param elements
	 */
	public TestForm(int value, String text, List elements) {
		super();
		this.value = value;
		this.text = text;
		this.elements = elements;
	}

	/**
	 * @return Returns the elements.
	 */
	public List getElements() {
		return elements;
	}

	/**
	 * @param elements
	 *            The elements to set.
	 */
	public void setElements(List elements) {
		this.elements = elements;
	}

	/**
	 * @return Returns the text.
	 */
	public String getText() {
		return text;
	}

	/**
	 * @param text
	 *            The text to set.
	 */
	public void setText(String text) {
		this.text = text;
	}

	/**
	 * @return Returns the value.
	 */
	public int getValue() {
		return value;
	}

	/**
	 * @param value
	 *            The value to set.
	 */
	public void setValue(int value) {
		this.value = value;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString() {

		return "TestForm(" + value + "," + text + "," + elements + ")";
	}
}
