/**
 * The program(s) herein may be used  freely
 * for personal use only. It may not be sold, 
 * rented, leased, sublicensed  or  modified 
 * without permission of  the  author.  
 * 
 *           www.carlosbcruz.com
 *           
 * This program is provided "AS IS"  without 
 * warranty of any kind. In no event I  will
 * be liable  for  any  direct  or  indirect 
 * damage.
 */
package com.carlosbcruz.util;
/**
 * for personal use only. It may not be sold, 
 * rented, leased, sublicensed  or  modified 
 * without permission of  the  author.  
 * 
 *           www.carlosbcruz.com
 *           
 * This program is provided "AS IS"  without 
 * warranty of any kind. In no event I  will
 * be liable  for  any  direct  or  indirect 
 * damage.
 */

import java.io.IOException;
import java.util.zip.GZIPInputStream;
import java.util.zip.GZIPOutputStream;

import com.opensource.util.FastByteArrayOutputStream;

/**
 * Simple compression methods using GZIP.
 *   
 * @author Carlos Fernando Bella Cruz - <a href="mailto:pessoal@carlosbcruz.com">pessoal@carlosbcruz.com</a>
 */
public class ZipUtil {

    /**
     * Compress a string.
     * @param content The input string.
     * @return the compressed content into byte array.
     */
    public static byte[] zip(String content) {

        FastByteArrayOutputStream streamOutput = new FastByteArrayOutputStream();

        try {
            GZIPOutputStream zipOutputStream = new GZIPOutputStream(
                streamOutput);

            char c[] = content.toCharArray();

            for (int i = 0; i < c.length; i++) {
                zipOutputStream.write((int)c[i]);
            }

            zipOutputStream.flush();
            zipOutputStream.close();
        }
        catch(IOException e) {
            ExceptionSupport.handleException(e);
        }

        return streamOutput.toByteArray();
    }

    /**
     * Uncompress a byte array back into String.
     * @param content The compressed byte array.
     * @return The original String.
     */
    public static String unzip(byte[] content) {

        StringBuffer output = new StringBuffer();

        try {

            GZIPInputStream zipInputStream = new GZIPInputStream(
                new ByteInputStream(content));

            int i = -1;
            do {

                i = zipInputStream.read();

                if (i != -1) {
                    output.append(Character.toChars(i));
                }

            }
            while (i != -1);

        }
        catch(IOException e) {
            ExceptionSupport.handleException(e);
        }

        return output.toString();
    }
}
